From 1aeff92a1013f57f6c226cdb86210d583f4248ad Mon Sep 17 00:00:00 2001
From: Egbert Eich <eich@suse.com>
Date: Tue, 24 May 2022 08:27:27 +0200
Subject: [PATCH 31/34] Add missing calls to slurm_msg_set_r_uid()

Signed-off-by: Egbert Eich <eich@suse.com>
---
 src/common/slurm_protocol_api.c | 8 ++++++++
 src/slurmctld/backup.c          | 2 ++
 src/slurmctld/controller.c      | 2 ++
 src/slurmctld/proc_req.c        | 2 ++
 4 files changed, 14 insertions(+)

diff --git a/src/common/slurm_protocol_api.c b/src/common/slurm_protocol_api.c
index 1f4ccbacfa..23bc63f267 100644
--- a/src/common/slurm_protocol_api.c
+++ b/src/common/slurm_protocol_api.c
@@ -4317,6 +4317,14 @@ static void _rc_msg_setup(slurm_msg_t *msg, slurm_msg_t *resp_msg,
 	resp_msg->forward_struct = msg->forward_struct;
 	resp_msg->ret_list = msg->ret_list;
 	resp_msg->orig_addr = msg->orig_addr;
+	/* like _resp_msg_setup() */
+	if (!msg->auth_uid_set)
+                slurm_msg_set_r_uid(resp_msg, SLURM_AUTH_NOBODY);
+        else if ((msg->auth_uid != slurm_get_slurm_user_id()) &&
+                 (msg->auth_uid != slurm_get_slurmd_user_id()))
+                slurm_msg_set_r_uid(resp_msg, msg->auth_uid);
+        else
+                slurm_msg_set_r_uid(resp_msg, SLURM_AUTH_UID_ANY);
 }
 
 
diff --git a/src/slurmctld/backup.c b/src/slurmctld/backup.c
index 67d33dacc9..0c23b36e97 100644
--- a/src/slurmctld/backup.c
+++ b/src/slurmctld/backup.c
@@ -446,6 +446,7 @@ static int _ping_controller(void)
 	unlock_slurmctld(config_read_lock);
 
 	req.msg_type = REQUEST_PING;
+	slurm_msg_set_r_uid(&req, SLURM_AUTH_UID_ANY);
 
 	if (slurm_send_recv_rc_msg_only_one(&req, &rc, 0) < 0) {
 		error("_ping_controller/slurm_send_node_msg error: %m");
@@ -501,6 +502,7 @@ static int _shutdown_primary_controller(int wait_time)
 
 	/* send request message */
 	req.msg_type = REQUEST_CONTROL;
+	slurm_msg_set_r_uid(&req, SLURM_AUTH_UID_ANY);
 
 	if (slurm_send_recv_rc_msg_only_one(&req, &rc,
 				(CONTROL_TIMEOUT * 1000)) < 0) {
diff --git a/src/slurmctld/controller.c b/src/slurmctld/controller.c
index fa06e52005..391d1bff09 100644
--- a/src/slurmctld/controller.c
+++ b/src/slurmctld/controller.c
@@ -2489,6 +2489,7 @@ static int _shutdown_backup_controller(int wait_time)
 
 	/* send request message */
 	req.msg_type = REQUEST_CONTROL;
+	slurm_msg_set_r_uid(&req, SLURM_AUTH_UID_ANY);
 
 	if (slurm_send_recv_rc_msg_only_one(&req, &rc,
 				(CONTROL_TIMEOUT * 1000)) < 0) {
@@ -2999,6 +3000,7 @@ static int _ping_backup_controller(void)
 	unlock_slurmctld(config_read_lock);
 
 	req.msg_type = REQUEST_PING;
+	slurm_msg_set_r_uid(&req, SLURM_AUTH_UID_ANY);
 
 	if (slurm_send_recv_rc_msg_only_one(&req, &rc, 0) < 0) {
 		debug2("_ping_backup_controller/slurm_send_node_msg error: %m");
diff --git a/src/slurmctld/proc_req.c b/src/slurmctld/proc_req.c
index 0c025b95b3..20cfffd764 100644
--- a/src/slurmctld/proc_req.c
+++ b/src/slurmctld/proc_req.c
@@ -4620,6 +4620,8 @@ static void  _slurm_rpc_block_info(slurm_msg_t * msg)
 		response_msg.protocol_version = msg->protocol_version;
 		response_msg.address = msg->address;
 		response_msg.conn = msg->conn;
+		if (msg->auth_uid_set)
+                  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.msg_type = RESPONSE_BLOCK_INFO;
 		response_msg.data = get_buf_data(buffer);
 		response_msg.data_size = get_buf_offset(buffer);
-- 
2.35.3


